## ghdl 0.37+dfsg

=== doc/Makefile ===
CP=cp

# Sphinx options.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees -T -D language=en $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

all: ghdl.info

#---

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man

#---

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html

#---

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex

#---

texi: ghdl.texi
ghdl.texi:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	$(CP) $(BUILDDIR)/texinfo/GHDL.texi $@

info: ghdl.info
ghdl.info: ghdl.texi
	makeinfo -o $@ $<

dvi: ghdl.dvi
ghdl.dvi: ghdl.texi
	texi2dvi $<

ghdl.ps: ghdl.dvi
	dvips $<

pdf: ghdl.pdf
ghdl.pdf: ghdl.dvi
	dvipdf $<

#---

clean:
	$(RM) *~ *.dvi *.info ghdl.aux ghdl.cp ghdl.fn ghdl.ky ghdl.log
	$(RM) ghdl.pdf ghdl.pg ghdl.toc ghdl.tp ghdl.vr
	$(RM) -rf build

maintainer-clean: clean
	$(RM) ghdl.texi

=== doc/requirements.txt ===
#-r ../requirements.txt
sphinx>=1.5.2
recommonmark
sphinx_rtd_theme
python-dateutil
# sphinxcontrib-textstyle>=0.2.1
# sphinxcontrib-spelling>=2.2.0
# changelog>=0.3.5

=== src/edif/Makefile ===
GNATMAKE=gnatmake -j0
CFLAGS=-g
GNAT_FLAGS=-aI.. -aI../vhdl -aI../psl -aI../grt -gnat05 -gnaty3befhkmr -gnata -gnatf -gnatwae $(CFLAGS)
BE=debug
ortho_srcdir=../ortho
GEN_SRCS=edif-nodes.adb edif-nodes_meta.ads edif-nodes_meta.adb
CC=gcc

PNODES=../../python/xtools/pnodes.py
PNODES_ARGS=--field-file=edif-nodes.adb.in --kind-file=edif-nodes.ads --node-file=edif-nodes.ads --template-file=edif-nodes.adb.in --meta-basename=edif-nodes_meta --kind-type=Nkind --kind-range-prefix=Nkinds_ --kind-prefix=N_ --node-type=Node

all: dump_edif


dump_edif$(EXEEXT): $(GEN_SRCS) force
	$(GNATMAKE) $(GNAT_FLAGS) dump_edif

edif-nodes.adb: edif-nodes.adb.in edif-nodes.ads $(PNODES)
	$(RM) -f $@
	$(PNODES) $(PNODES_ARGS) body > $@
	chmod a-w $@

edif-nodes_meta.ads: edif-nodes_meta.ads.in edif-nodes.ads $(PNODES)
	$(RM) -f $@
	$(PNODES) $(PNODES_ARGS) meta_specs > $@
	chmod a-w $@

edif-nodes_meta.adb: edif-nodes_meta.adb.in edif-nodes.ads $(PNODES)
	$(RM) -f $@
	$(PNODES) $(PNODES_ARGS) --keep-order meta_body > $@
	chmod a-w $@

clean: force
	$(RM) -f *.o *.ali dump_edif  *.cf b~*.ad?

maintainer-clean: clean
	$(RM) -f $(GEN_SRCS)

force:

=== src/psl/Makefile ===
#  Copyright (C) 2002 - 2015 Tristan Gingold
#
#  GHDL is free software; you can redistribute it and/or modify it under
#  the terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 2, or (at your option) any later
#  version.
#
#  GHDL is distributed in the hope that it will be useful, but WITHOUT ANY
#  WARRANTY; without even the implied warranty of MERCHANTABILITY or
#  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#  for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with GCC; see the file COPYING.  If not, write to the Free
#  Software Foundation, 59 Temple Place - Suite 330, Boston, MA
#  02111-1307, USA.

# Some files are automatically generated using pnodes.py
# This Makefile can be used to regenerate these files.  Generated files must
# be committed and distribued with the sources, so that users don't need to
# regenerate them (and don't need to have python installed).

PNODES=../../python/xtools/pnodes.py

DEPS=psl-nodes.ads psl-nodes.adb.in $(PNODES)

PNODES_FLAGS=--field-file=psl-nodes.adb.in --kind-file=psl-nodes.ads --node-file=psl-nodes.ads --template-file=psl-nodes.adb.in --meta-basename=psl-nodes_meta --kind-type=Nkind --kind-prefix=N_ --node-type=Node

GEN_FILES=psl-nodes.adb psl-nodes_meta.ads psl-nodes_meta.adb

all: $(GEN_FILES)

psl-nodes.adb: psl-nodes.adb.in $(DEPS)
	$(RM) $@
	$(PNODES) $(PNODES_FLAGS) body > $@
	chmod -w $@

psl-nodes_meta.ads: psl-nodes_meta.ads.in $(DEPS)
	$(RM) $@
	$(PNODES) $(PNODES_FLAGS) meta_specs > $@
	chmod -w $@

psl-nodes_meta.adb: psl-nodes_meta.adb.in $(DEPS)
	$(RM) $@
	$(PNODES) $(PNODES_FLAGS) meta_body > $@
	chmod -w $@

clean:
	$(RM) -f $(GEN_FILES)

=== src/vhdl/Makefile ===
#  Copyright (C) 2002 - 2015 Tristan Gingold
#
#  GHDL is free software; you can redistribute it and/or modify it under
#  the terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 2, or (at your option) any later
#  version.
#
#  GHDL is distributed in the hope that it will be useful, but WITHOUT ANY
#  WARRANTY; without even the implied warranty of MERCHANTABILITY or
#  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#  for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with GCC; see the file COPYING.  If not, write to the Free
#  Software Foundation, 59 Temple Place - Suite 330, Boston, MA
#  02111-1307, USA.

# Some files are automatically generated using pnodes.py
# This Makefile can be used to regenerate these files.  Generated files must
# be committed and distribued with the sources, so that users don't need to
# regenerate them (and don't need to have python installed).

PNODES=../../python/xtools/pnodes.py
PNODESPY=../../python/xtools/pnodespy.py

DEPS=vhdl-nodes.ads vhdl-nodes.adb.in $(PNODES)

GEN_FILES=vhdl-nodes.adb vhdl-nodes_meta.ads vhdl-nodes_meta.adb \
  vhdl-elocations.adb vhdl-elocations_meta.ads vhdl-elocations_meta.adb \
  ../../python/libghdl/thin/vhdl/nodes.py \
  ../../python/libghdl/thin/vhdl/nodes_meta.py \
  ../../python/libghdl/thin/vhdl/tokens.py \
  ../../python/libghdl/thin/vhdl/elocations.py \
  ../../python/libghdl/thin/errorout.py ../../python/libghdl/thin/std_names.py

NODES_FLAGS=--node-file=vhdl-nodes.ads --field-file=vhdl-nodes.adb.in \
  --template-file=vhdl-nodes.adb.in --kind-file=vhdl-nodes.ads \
  --meta-basename=vhdl-nodes_meta

ELOCATIONS_FLAGS=--node-file=vhdl-elocations.ads \
  --field-file=vhdl-elocations.adb.in --kind-file=vhdl-nodes.ads \
  --template-file=vhdl-elocations.adb.in --meta-basename=vhdl-elocations_meta

all: $(GEN_FILES)

vhdl-nodes.adb: vhdl-nodes.adb.in $(DEPS)
	$(RM) $@
	$(PNODES) $(NODES_FLAGS) body > $@
	chmod -w $@

vhdl-nodes_meta.ads: vhdl-nodes_meta.ads.in $(DEPS)
	$(RM) $@
	$(PNODES) $(NODES_FLAGS) meta_specs > $@
	chmod -w $@

vhdl-nodes_meta.adb: vhdl-nodes_meta.adb.in $(DEPS)
	$(RM) $@
	$(PNODES) $(NODES_FLAGS) meta_body > $@
	chmod -w $@

vhdl-elocations.adb: vhdl-elocations.adb.in vhdl-elocations.ads $(DEPS)
	$(RM) $@
	$(PNODES) $(ELOCATIONS_FLAGS) body > $@
	chmod -w $@

vhdl-elocations_meta.ads: vhdl-elocations_meta.ads.in vhdl-elocations.ads $(DEPS)
	$(RM) $@
	$(PNODES) $(ELOCATIONS_FLAGS) meta_specs > $@
	chmod -w $@

vhdl-elocations_meta.adb: vhdl-elocations_meta.adb.in vhdl-elocations.ads $(DEPS)
	$(RM) $@
	$(PNODES) $(ELOCATIONS_FLAGS) meta_body > $@
	chmod -w $@

../../python/libghdl/thin/vhdl/nodes.py: $(DEPS) $(PNODESPY)
	$(RM) $@
	$(PNODESPY) $(NODES_FLAGS) libghdl-nodes > $@
	chmod -w $@

../../python/libghdl/thin/vhdl/nodes_meta.py: $(DEPS) $(PNODESPY)
	$(RM) $@
	$(PNODESPY) $(NODES_FLAGS) libghdl-meta > $@
	chmod -w $@

../../python/libghdl/thin/std_names.py: $(PNODESPY) ../std_names.ads
	$(RM) $@
	$(PNODESPY) $(NODES_FLAGS) libghdl-names > $@
	chmod -w $@

../../python/libghdl/thin/vhdl/tokens.py: $(PNODESPY) vhdl-tokens.ads
	$(RM) $@
	$(PNODESPY) $(NODES_FLAGS) libghdl-tokens > $@
	chmod -w $@

../../python/libghdl/thin/vhdl/elocations.py: $(PNODESPY) vhdl-elocations.ads
	$(RM) $@
	$(PNODESPY) $(ELOCATIONS_FLAGS) libghdl-elocs > $@
	chmod -w $@

../../python/libghdl/thin/errorout.py: $(PNODESPY) ../errorout.ads
	$(RM) $@
	$(PNODESPY) $(ELOCATIONS_FLAGS) libghdl-errorout > $@
	chmod -w $@

clean:
	$(RM) -f $(GEN_FILES)

=== src/ortho/gcc/Makefile ===
ortho_srcdir=..
orthobe_srcdir=$(ortho_srcdir)/gcc
ortho_lang_c=ortho-lang-7.c
agcc_objdir=.
agcc_srcdir=$(ortho_srcdir)/gcc
SED=sed
BE=gcc
GNATMAKE=gnatmake
CC=gcc
CXX=g++
COMPILER=$(CXX)
LINKER=$(CXX)

# Modify AGCC_GCCSRC_DIR and AGCC_GCCOBJ_DIR for your environment
AGCC_GCCSRC_DIR:=$(HOME)/Projects/gcc4.9.2/source/gcc-4.9.2/
AGCC_GCCOBJ_DIR:=$(HOME)/Projects/gcc4.9.2/build/

# Supplied by main GCC Makefile, copied here for compatibility with same
GMPLIBS = -L$(AGCC_GCCOBJ_DIR)./gmp/.libs -L$(AGCC_GCCOBJ_DIR)./mpfr/.libs \
  -L$(AGCC_GCCOBJ_DIR)./mpc/src/.libs -lmpc -lmpfr -lgmp
GMPINC = -I$(AGCC_GCCOBJ_DIR)./gmp -I$(AGCC_GCCSRC_DIR)/gmp \
  -I$(AGCC_GCCOBJ_DIR)./mpfr -I$(AGCC_GCCSRC_DIR)/mpfr \
  -I$(AGCC_GCCSRC_DIR)/mpc/src

HOST_LIBS =
ZLIB=-lz

# Override variables in Makefile.conf for your environment
-include $(orthobe_srcdir)/Makefile.conf

all: $(ortho_exec)

ORTHO_BASENAME=ortho_gcc
include $(ortho_srcdir)/Makefile.inc

AGCC_INC_FLAGS=-I$(AGCC_GCCOBJ_DIR)/gcc -I$(AGCC_GCCSRC_DIR)/include \
 -I$(AGCC_GCCSRC_DIR)/gcc -I$(AGCC_GCCSRC_DIR)/gcc/config \
 -I$(AGCC_GCCSRC_DIR)/libcpp/include $(GMPINC)
AGCC_CFLAGS=-DIN_GCC_FRONTEND -Wall -DIN_GCC -DHAVE_CONFIG_H $(AGCC_INC_FLAGS)

ortho-lang.o: $(agcc_srcdir)/$(ortho_lang_c) \
 $(AGCC_GCCOBJ_DIR)gcc/gtype-vhdl.h \
 $(AGCC_GCCOBJ_DIR)gcc/gt-vhdl-ortho-lang.h
	$(COMPILER) -c -o $@ $< $(AGCC_CFLAGS) $(CXXFLAGS) $(INCLUDES)

AGCC_LOCAL_OBJS=ortho-lang.o

AGCC_DEPS := $(AGCC_LOCAL_OBJS)
AGCC_OBJS := $(AGCC_LOCAL_OBJS) \
	$(AGCC_GCCOBJ_DIR)gcc/attribs.o \
	$(AGCC_GCCOBJ_DIR)libcpp/libcpp.a \
	$(AGCC_GCCOBJ_DIR)libiberty/libiberty.a

LIBBACKTRACE = $(AGCC_GCCOBJ_DIR)/libbacktrace/.libs/libbacktrace.a
LIBDECNUMBER = $(AGCC_GCCOBJ_DIR)/libdecnumber/libdecnumber.a
LIBIBERTY = $(AGCC_GCCOBJ_DIR)/libiberty/libiberty.a
CPPLIB= # Not needed for GHDL

BACKEND = $(AGCC_GCCOBJ_DIR)/gcc/libbackend.a \
         $(AGCC_GCCOBJ_DIR)/gcc/libcommon-target.a

BACKENDLIBS = $(CLOOGLIBS) $(GMPLIBS) $(PLUGINLIBS) $(HOST_LIBS) \
	$(ZLIB)
LIBS =  $(AGCC_GCCOBJ_DIR)/gcc/libcommon.a \
        $(CPPLIB) $(LIBINTL) $(LIBICONV) $(LIBBACKTRACE) \
	$(LIBIBERTY) $(LIBDECNUMBER) $(HOST_LIBS)

$(ortho_exec): $(AGCC_DEPS) $(orthobe_srcdir)/ortho_gcc.ads force
	$(GNATMAKE) -o $@ -aI$(ortho_srcdir) \
	 -aI$(ortho_srcdir)/gcc $(GNATFLAGS) ortho_gcc-main \
	 -bargs -E -largs --LINK=$(LINKER) $(AGCC_OBJS) \
        $(BACKEND) $(LIBS) $(BACKENDLIBS)

agcc-clean: force
	$(RM) -f $(agcc_objdir)/*.o
	$(RM) -f $(agcc_srcdir)/*~

clean: agcc-clean
	$(RM) -f *.o *.ali ortho_nodes-main
	$(RM) b~*.ad? *~

distclean: clean agcc-clean


force:

.PHONY: force all clean agcc-clean

=== src/ortho/llvm4-nodebug/Makefile ===
ortho_srcdir=..
GNATFLAGS=-gnaty3befhkmr -gnata -gnatf -gnatwael
CXX=clang++
LLVM_CONFIG=llvm-config
GNATMAKE=gnatmake
SED=sed
BE=llvm4-nodebug

LLVM_LDFLAGS=$(LLVM_CONFIG) --ldflags --libs --system-libs

all: $(ortho_exec)

$(ortho_exec): $(ortho_srcdir)/llvm4-nodebug/ortho_llvm.ads force llvm-cbindings.o
	$(GNATMAKE) -o $@ -aI$(ortho_srcdir)/llvm4-nodebug -aI$(ortho_srcdir) \
	$(GNATFLAGS) ortho_code_main -bargs -E \
	-largs llvm-cbindings.o --LINK=$(CXX) \
	$(LDFLAGS) `$(LLVM_LDFLAGS)`

llvm-cbindings.o: $(ortho_srcdir)/llvm4-nodebug/llvm-cbindings.cpp
	$(CXX) -c `$(LLVM_CONFIG) --cxxflags` -o $@ $<

clean:
	$(RM) -f *.o *.ali ortho_code_main
	$(RM) b~*.ad? *~

distclean: clean


force:

.PHONY: force all clean

ORTHO_BASENAME=ortho_llvm
include $(ortho_srcdir)/Makefile.inc

=== src/ortho/oread/Makefile ===
#  -*- Makefile -*- for the ortho-code compiler.
#  Copyright (C) 2005 Tristan Gingold
#
#  GHDL is free software; you can redistribute it and/or modify it under
#  the terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 2, or (at your option) any later
#  version.
#
#  GHDL is distributed in the hope that it will be useful, but WITHOUT ANY
#  WARRANTY; without even the implied warranty of MERCHANTABILITY or
#  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#  for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with GCC; see the file COPYING.  If not, write to the Free
#  Software Foundation, 59 Temple Place - Suite 330, Boston, MA
#  02111-1307, USA.
BE = gcc
ortho_srcdir=..
BACK_END=$(ortho_srcdir)/$(BE)
ortho_exec=oread-$(BE)

all: $(ortho_exec)

test: test.s
	$(CC) -o $@ $^

test.s: $(ortho_exec)
	./$(ortho_exec) test

$(ortho_exec): force
	$(MAKE) -f $(BACK_END)/Makefile ortho_exec=$(ortho_exec)

clean:
	$(MAKE) -f $(BACK_END)/Makefile clean
	$(RM) -f oread-gcc oread-mcode *.o *~

distclean: clean
	$(MAKE) -f $(BACK_END)/Makefile distclean

force:

.PHONY: force

=== debian/changelog ===
ghdl (0.37+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Update watchfile to ignore date tags
  * Switch to GCC/GNAT 10. Thanks to Ludovic Brenta (Closes: #970660)
  * Allow builds with LLVM 11 (Closes: #976233)

 -- Jonathan McDowell <noodles@earth.li>  Sat, 05 Dec 2020 13:36:28 +0000

ghdl (0.37+dfsg-2) unstable; urgency=medium

  * Team upload.

  [ Frédéric Bonnard ]
  * Really fix FTBFS on ppc64* (Closes: #907170)

 -- Jonathan McDowell <noodles@earth.li>  Sun, 17 May 2020 10:07:15 +0100

ghdl (0.37+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    * Refresh modify-install-paths
    * Remove patch allowing LLVM 8 (upstreamed)
    * Fixes build with LLVM 9 (Closes: #952110)
    * Update wrapper for newer releases. Thanks to Pavel Pisa (Closes: #930890)
  * Switch to GCC 9 (Closes: #944181)

 -- Jonathan McDowell <noodles@earth.li>  Mon, 06 Apr 2020 11:57:15 +0100

ghdl (0.35+git20181129+dfsg-4) unstable; urgency=medium

  * Team upload.
  * Allow building with LLVM 8+. Patch thanks to Logan Rosen (Closes: #923190)

 -- Jonathan McDowell <noodles@earth.li>  Sun, 29 Sep 2019 18:05:58 +0100

=== debian/control ===
Source: ghdl
Section: electronics
Priority: optional
Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
Uploaders: Andreas Bombe <aeb@debian.org>
Build-Depends: debhelper (>= 11),
               gnat-10,
               gcc-10-source <!pkg.ghdl.nogcc>,
               libisl-dev (>= 0.14) <!pkg.ghdl.nogcc>,
               libmpc-dev (>= 1.0) <!pkg.ghdl.nogcc>,
               libmpfr-dev (>= 3.0.0-9~) <!pkg.ghdl.nogcc>,
               libgmp-dev (>= 2:5.0.1~) <!pkg.ghdl.nogcc>,
               llvm-dev (>= 1:3.5) <!pkg.ghdl.nollvm>,
               clang (>= 1:3.5) <!pkg.ghdl.nollvm>,
               zlib1g-dev
Standards-Version: 4.2.0
Homepage: https://github.com/ghdl/ghdl
Vcs-Browser: https://salsa.debian.org/electronics-team/ghdl/ghdl
Vcs-Git: https://salsa.debian.org/electronics-team/ghdl/ghdl.git
Rules-Requires-Root: no

Package: ghdl
Architecture: any
Multi-Arch: same
Depends: ghdl-mcode [any-i386 any-amd64] <!pkg.ghdl.nomcode>
         | ghdl-gcc <!pkg.ghdl.nogcc>
         | ghdl-llvm <!pkg.ghdl.nollvm>,
         ${misc:Depends}
Suggests: gtkwave
Description: VHDL compiler/simulator
 GHDL is a compiler and simulator for VHDL, a Hardware Description Language.
 GHDL is not an interpreter: it allows you to analyse and elaborate sources to
 generate machine code from your design. Native program execution is the only
 way for high speed simulation.
 .
 GHDL offers three machine code generation backends: one based on GCC, one
 using the LLVM compiler suite and a GHDL specific one called mcode. These are
 available in the ghdl-gcc, ghdl-llvm and ghdl-mcode packages respectively.
 Both the GCC and LLVM backends create highly optimized code for excellent
 simulation performance while simulations compiled with the GCC backend also
 allow coverage testing using gcov. The mcode backend creates less performant
 code but makes up for it with much faster compilation. It is therefore
 preferable for smaller projects without large or long running simulations.
 .
 Multiple backends can be installed at the same time and selected by either
 invoking the desired GHDL directly (as ghdl-gcc, ghdl-llvm or ghdl-mcode) or
 by providing a GHDL_BACKEND environment variable (containing gcc, llvm or
 mcode) while invoking ghdl.
 .
 This package contains the common files for all backends and requires at least
 one backend to be installed.

Package: ghdl-mcode
Architecture: any-i386 any-amd64
Build-Profiles: <!pkg.ghdl.nomcode>
Depends: ghdl (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: VHDL compiler/simulator (mcode backend)
 GHDL is a compiler and simulator for VHDL, a Hardware Description Language.
 GHDL is not an interpreter: it allows you to analyse and elaborate sources to
 generate machine code from your design. Native program execution is the only
 way for high speed simulation.
 .
 This package contains the compiler with the mcode backend.

Package: ghdl-gcc
Architecture: any
Build-Profiles: <!pkg.ghdl.nogcc>
Depends: ghdl (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends},
	zlib1g-dev
Description: VHDL compiler/simulator (GCC backend)
 GHDL is a compiler and simulator for VHDL, a Hardware Description Language.
 GHDL is not an interpreter: it allows you to analyse and elaborate sources to
 generate machine code from your design. Native program execution is the only
 way for high speed simulation.
 .
 This package contains the compiler with the GCC backend.

Package: ghdl-llvm
Architecture: any
Build-Profiles: <!pkg.ghdl.nollvm>
Depends: ghdl (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends},
	zlib1g-dev
Description: VHDL compiler/simulator (LLVM backend)
 GHDL is a compiler and simulator for VHDL, a Hardware Description Language.
 GHDL is not an interpreter: it allows you to analyse and elaborate sources to
 generate machine code from your design. Native program execution is the only
 way for high speed simulation.
 .
 This package contains the compiler with the LLVM backend.

=== debian/rules ===
#!/usr/bin/make -f

# Currently gcc can not be compiled with format-security and it is not needed
# for Ada code anyway
export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-format

#export DH_VERBOSE = 1

# These variables are used to find and unpack the gcc source
GCC_DIR := /usr/src/gcc-10
GCC_VER := 10
GCC_TARBALL := $(notdir $(wildcard $(GCC_DIR)/gcc-*.tar.*))

include /usr/share/dpkg/default.mk
include /usr/share/ada/debian_packaging-$(GCC_VER).mk

# This variable is used in Makefile.in to adjust src/version.in
export PKG_VERSION := $(DEB_VENDOR) $(DEB_VERSION)

# Get parallel option to parallelize the gcc build specifically (Ada builds
# are already parallelized by code included from debian_packaging-*.mk above).
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    MAKEPARALLEL = -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

# build profile control over what backends get built
ifeq ($(filter pkg.ghdl.nomcode,$(DEB_BUILD_PROFILES)),)
    WITH_MCODE := 1
endif
ifeq ($(filter pkg.ghdl.nogcc,$(DEB_BUILD_PROFILES)),)
    WITH_GCC   := 1
endif
ifeq ($(filter pkg.ghdl.nollvm,$(DEB_BUILD_PROFILES)),)
    WITH_LLVM  := 1
endif

# force disable mcode build on non-x86 architectures where it isn't supported
ifeq ($(filter amd64 i386,$(DEB_HOST_ARCH_CPU)),)
    WITH_MCODE :=
endif

BUILDDIR := $(CURDIR)/builddir
CC := gnatgcc
export CC


%:
	dh ${@}

override_dh_missing:
	dh_missing --list-missing

override_dh_auto_configure:
	mkdir -p $(BUILDDIR)/mcode $(BUILDDIR)/llvm $(BUILDDIR)/gcc
	@echo
	@echo ------------------------------------------------------------
	@echo Configuring with mcode backend
	@echo ------------------------------------------------------------
	if [ -n "$(WITH_MCODE)" ]; then \
		cd $(BUILDDIR)/mcode; \
		../../configure --srcdir=../.. --prefix=/usr \
			--libdir=lib/ghdl/mcode --incdir=lib/ghdl/include \
			--enable-openieee; \
	fi
	@echo
	@echo ------------------------------------------------------------
	@echo Configuring with llvm backend
	@echo ------------------------------------------------------------
	if [ -n "$(WITH_LLVM)" ]; then \
		cd $(BUILDDIR)/llvm; \
		../../configure --srcdir=../.. --prefix=/usr \
			--libdir=lib/ghdl/llvm --incdir=lib/ghdl/include \
			--enable-openieee --with-llvm-config; \
	fi
	@echo
	@echo ------------------------------------------------------------
	@echo Configuring with gcc backend
	@echo ------------------------------------------------------------
	# gcc unpack sequence cribbed from gcc-7-cross debian/rules
	set -e; \
	if [ -n "$(WITH_GCC)" ]; then \
		cd $(BUILDDIR)/gcc; \
		ln -sf ${GCC_DIR}/$(GCC_TARBALL) $(GCC_TARBALL); \
		cp -a  ${GCC_DIR}/debian/ .; \
		if [ -n "$$(grep -v '^\#' ${CURDIR}/debian/patches/gcc-${GCC_VER}/series)" ]; then \
			cp -n ${CURDIR}/debian/patches/gcc-${GCC_VER}/*.diff debian/patches/ ; \
			cat ${CURDIR}/debian/patches/gcc-${GCC_VER}/series >> debian/patches/series ; \
			sed -i "s/\(^series_stamp.*\)/debian_patches += $$(grep -v '^#' ${CURDIR}/debian/patches/gcc-${GCC_VER}/series|sed 's/\..*//'|tr '\n' ' ')\n\n\1/" debian/rules.patch ; \
		fi; \
		debian/rules patch; \
		../../configure --srcdir=../.. --prefix=/usr \
			--libdir=lib/ghdl/gcc --incdir=lib/ghdl/include \
			--enable-openieee --with-gcc=src; \
		make copy-sources; \
		mkdir gccbuild; \
		cd gccbuild; \
		../src/configure --prefix=/usr/lib/ghdl/gcc --enable-languages=vhdl \
			--enable-default-pie \
			--disable-bootstrap --disable-lto --disable-multilib \
			--disable-libssp --disable-libgomp --disable-libquadmath \
			--with-system-zlib --without-isl; \
	fi

override_dh_auto_build:
	@echo
	@echo ------------------------------------------------------------
	@echo Building with mcode backend
	@echo ------------------------------------------------------------
	if [ -n "$(WITH_MCODE)" ]; then \
		$(MAKE) -C $(BUILDDIR)/mcode; \
	fi
	@echo
	@echo ------------------------------------------------------------
	@echo Building with llvm backend
	@echo ------------------------------------------------------------
	if [ -n "$(WITH_LLVM)" ]; then \
		$(MAKE) -C $(BUILDDIR)/llvm; \
	fi
	@echo
	@echo ------------------------------------------------------------
	@echo Building with gcc backend
	@echo ------------------------------------------------------------
	if [ -n "$(WITH_GCC)" ]; then \
		$(MAKE) $(MAKEPARALLEL) -C $(BUILDDIR)/gcc/gccbuild; \
		$(MAKE) -C $(BUILDDIR)/gcc lib/ghdl/gcc/libgrt.a all.vpi; \
		$(MAKE) -C $(BUILDDIR)/gcc ghdllib \
			GHDL_GCC_BIN=$(BUILDDIR)/gcc/gccbuild/gcc/ghdl \
			GHDL1_GCC_BIN="--GHDL1=$(BUILDDIR)/gcc/gccbuild/gcc/ghdl1"; \
	fi

override_dh_auto_install:
	install -pD debian/ghdl.wrapper $(CURDIR)/debian/tmp/usr/bin/ghdl
	@echo
	@echo ------------------------------------------------------------
	@echo Installing with mcode backend
	@echo ------------------------------------------------------------
	if [ -n "$(WITH_MCODE)" ]; then \
		$(MAKE) -C $(BUILDDIR)/mcode install DESTDIR=../../debian/tmp; \
	fi
	@echo
	@echo ------------------------------------------------------------
	@echo Installing with llvm backend
	@echo ------------------------------------------------------------
	if [ -n "$(WITH_LLVM)" ]; then \
		$(MAKE) -C $(BUILDDIR)/llvm install DESTDIR=../../debian/tmp; \
	fi
	@echo
	@echo ------------------------------------------------------------
	@echo Installing with gcc backend
	@echo ------------------------------------------------------------
	if [ -n "$(WITH_GCC)" ]; then \
		$(MAKE) -C $(BUILDDIR)/gcc/gccbuild install \
			DESTDIR=$(CURDIR)/debian/tmp; \
		$(MAKE) -C $(BUILDDIR)/gcc install DESTDIR=$(CURDIR)/debian/tmp; \
		mv debian/tmp/usr/lib/ghdl/gcc/bin/ghdl-gcc debian/tmp/usr/bin/ghdl-gcc; \
		mv debian/tmp/usr/lib/ghdl/gcc/lib/ghdl/libbacktrace.a debian/tmp/usr/lib/ghdl/gcc/vhdl/libbacktrace.a; \
	fi
	@echo
	@echo ------------------------------------------------------------
	@echo Moving parts to required locations
	@echo ------------------------------------------------------------
	if [ -n "$(WITH_MCODE)" ]; then \
		$(RM) -r debian/tmp/usr/lib/ghdl/src; \
		mv debian/tmp/usr/lib/ghdl/mcode/vhdl/src debian/tmp/usr/lib/ghdl; \
		ln -s ../../src debian/tmp/usr/lib/ghdl/mcode/vhdl/src; \
	fi
	if [ -n "$(WITH_LLVM)" ]; then \
		$(RM) -r debian/tmp/usr/lib/ghdl/src; \
		mv debian/tmp/usr/lib/ghdl/llvm/vhdl/src debian/tmp/usr/lib/ghdl; \
		ln -s ../../src debian/tmp/usr/lib/ghdl/llvm/vhdl/src; \
	fi
	if [ -n "$(WITH_GCC)" ]; then \
		$(RM) -r debian/tmp/usr/lib/ghdl/src; \
		mv debian/tmp/usr/lib/ghdl/gcc/vhdl/src debian/tmp/usr/lib/ghdl; \
		ln -s ../../src debian/tmp/usr/lib/ghdl/gcc/vhdl/src; \
	fi

=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg$//, repacksuffix=+dfsg, \
    filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%ghdl-$1.tar.gz%" \
    https://github.com/ghdl/ghdl/releases \
    (?:.*?/)?v?(\d*\.[\d.]*)\.tar\.gz debian uupdate

## ghdl 0.37+dfsg2

=== src/ortho/debug/Makefile ===
#  -*- Makefile -*- for the ortho-code back-end
#  Copyright (C) 2005 Tristan Gingold
#
#  GHDL is free software; you can redistribute it and/or modify it under
#  the terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 2, or (at your option) any later
#  version.
#
#  GHDL is distributed in the hope that it will be useful, but WITHOUT ANY
#  WARRANTY; without even the implied warranty of MERCHANTABILITY or
#  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#  for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with GCC; see the file COPYING.  If not, write to the Free
#  Software Foundation, 59 Temple Place - Suite 330, Boston, MA
#  02111-1307, USA.
BE=debug
ortho_srcdir=..

orthobe_srcdir=$(ortho_srcdir)/$(BE)

GNATMAKE=gnatmake
CC=gcc
CFLAGS=-g
ALL_GNAT_FLAGS=-pipe -g -gnato -gnatwaeu -gnatf -gnaty3befhkmr
GNATMAKE_FLAGS=$(ALL_GNAT_FLAGS) $(GNATFLAGS) -aI$(ortho_srcdir) -aI$(orthobe_srcdir) -aI.
#LARGS=-largs -static
SED=sed

all: $(ortho_exec)


$(ortho_exec): force $(ortho_srcdir)/$(BE)/ortho_debug.ads
	$(GNATMAKE) -o $@ $(GNATMAKE_FLAGS) ortho_debug-main -bargs -E $(LARGS)

clean:
	$(RM) -f *.o *.ali *~ b~*.ad? ortho_nodes-main
	$(RM) ortho_debug.ads

force:

ORTHO_BASENAME=ortho_debug

# Automatically build ortho_debug.ads from ortho_node.common.ads and
# ortho_debug.private.ads
include $(ortho_srcdir)/Makefile.inc

=== testsuite/gna/issue301/Makefile ===
###############################################################################
# Copyright (c) 2015 Potential Ventures Ltd
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Potential Ventures Ltd,
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL POTENTIAL VENTURES LTD BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
###############################################################################

TOPLEVEL_LANG ?= vhdl

ifneq ($(TOPLEVEL_LANG),vhdl)

all:
	@echo "Skipping test due to TOPLEVEL_LANG=$(TOPLEVEL_LANG) not being vhdl"
clean::

else

TOPLEVEL = dec_viterbi_top

ifeq ($(OS),Msys)
WPWD=$(shell sh -c 'pwd -W')
else
WPWD=$(shell pwd)
endif

COCOTB?=$(WPWD)/../../..

SRC_BASE = $(COCOTB)/tests/designs/viterbi_decoder_axi4s

RTL_LIBRARY = dec_viterbi

VHDL_SOURCES = $(SRC_BASE)/packages/pkg_helper.vhd \
	       $(SRC_BASE)/packages/pkg_param.vhd \
	       $(SRC_BASE)/packages/pkg_param_derived.vhd \
	       $(SRC_BASE)/packages/pkg_types.vhd \
	       $(SRC_BASE)/packages/pkg_components.vhd \
	       $(SRC_BASE)/packages/pkg_trellis.vhd \
	       $(SRC_BASE)/src/generic_sp_ram.vhd \
	       $(SRC_BASE)/src/axi4s_buffer.vhd \
	       $(SRC_BASE)/src/branch_distance.vhd \
	       $(SRC_BASE)/src/traceback.vhd \
	       $(SRC_BASE)/src/acs.vhd \
	       $(SRC_BASE)/src/ram_ctrl.vhd \
	       $(SRC_BASE)/src/reorder.vhd \
	       $(SRC_BASE)/src/recursion.vhd \
	       $(SRC_BASE)/src/dec_viterbi.vhd \

include $(COCOTB)/makefiles/Makefile.inc
include $(COCOTB)/makefiles/Makefile.sim

endif

=== debian/changelog ===
ghdl (0.37+dfsg2-2) unstable; urgency=medium

  * Add Breaks+Replaces ghdl (<< 0.37+dfsg2) on ghdl-common (Closes: #981576)
  * Do not install LICENSE file into /usr/lib/ghdl/src/ieee2008

 -- Andreas Bombe <aeb@debian.org>  Wed, 03 Feb 2021 02:40:10 +0100

ghdl (0.37+dfsg2-1) unstable; urgency=medium

  * Repack as 0.37+dfsg2
    * Add exclusion of some testsuite files in DFSG repack
    * Stop excluding libraries/ieee and libraries/ieee2008 in DFSG repack as
      they are now under a DFSG-free license (Apache 2.0)
    * Use the now DFSG-free IEEE libraries instead of GHDL's OpenIEEE
      substitute (Closes: #929656)
    * Add patch remove-vital-from-build to account for libraries removed in
      repack
    * Expand dversionmangle in d/watch to remove numbers after "+dfsg"
  * Introduce ghdl-common package to avoid a circular dependency
    (Closes: #916485)
    * Remove Multi-Arch: same on the ghdl package for now
  * Install all docs in ghdl-common and make other doc directories symlinks
  * Update copyright years in d/copyright
  * Add copyright and licensing for the testsuite to d/copyright
  * Disable building libghdl for now
  * Remove spelling-error lintian overrides for "Synopsys"
  * Point d/watch at releases/latest on GitHub to pick up the correct release
  * Increase debhelper compat level to 13
  * Bump Standards-Version to 4.5.1

 -- Andreas Bombe <aeb@debian.org>  Fri, 29 Jan 2021 15:46:02 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
 Uploaders: Andreas Bombe <aeb@debian.org>
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 13),
                gnat-10,
                gcc-10-source <!pkg.ghdl.nogcc>,
                libisl-dev (>= 0.14) <!pkg.ghdl.nogcc>,
@@ -13,7 +13,7 @@
                llvm-dev (>= 1:3.5) <!pkg.ghdl.nollvm>,
                clang (>= 1:3.5) <!pkg.ghdl.nollvm>,
                zlib1g-dev
-Standards-Version: 4.2.0
+Standards-Version: 4.5.1
 Homepage: https://github.com/ghdl/ghdl
 Vcs-Browser: https://salsa.debian.org/electronics-team/ghdl/ghdl
 Vcs-Git: https://salsa.debian.org/electronics-team/ghdl/ghdl.git
@@ -21,8 +21,8 @@
 
 Package: ghdl
 Architecture: any
-Multi-Arch: same
-Depends: ghdl-mcode [any-i386 any-amd64] <!pkg.ghdl.nomcode>
+Depends: ghdl-common (= ${binary:Version}),
+         ghdl-mcode [any-i386 any-amd64] <!pkg.ghdl.nomcode>
          | ghdl-gcc <!pkg.ghdl.nogcc>
          | ghdl-llvm <!pkg.ghdl.nollvm>,
          ${misc:Depends}
@@ -47,13 +47,26 @@
  by providing a GHDL_BACKEND environment variable (containing gcc, llvm or
  mcode) while invoking ghdl.
  .
- This package contains the common files for all backends and requires at least
- one backend to be installed.
+ This package is a dependency package that will make sure at least one backend
+ is installed.
+
+Package: ghdl-common
+Architecture: any
+Depends: ${misc:Depends}
+Breaks: ghdl (<< 0.37+dfsg2)
+Replaces: ghdl (<< 0.37+dfsg2)
+Description: VHDL compiler/simulator (common files)
+ GHDL is a compiler and simulator for VHDL, a Hardware Description Language.
+ GHDL is not an interpreter: it allows you to analyse and elaborate sources to
+ generate machine code from your design. Native program execution is the only
+ way for high speed simulation.
+ .
+ This package contains common files for the GHDL compiler packages.
 
 Package: ghdl-mcode
 Architecture: any-i386 any-amd64
 Build-Profiles: <!pkg.ghdl.nomcode>
-Depends: ghdl (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
+Depends: ghdl-common (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
 Description: VHDL compiler/simulator (mcode backend)
  GHDL is a compiler and simulator for VHDL, a Hardware Description Language.
  GHDL is not an interpreter: it allows you to analyse and elaborate sources to
@@ -65,7 +78,7 @@
 Package: ghdl-gcc
 Architecture: any
 Build-Profiles: <!pkg.ghdl.nogcc>
-Depends: ghdl (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends},
+Depends: ghdl-common (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends},
 	zlib1g-dev
 Description: VHDL compiler/simulator (GCC backend)
  GHDL is a compiler and simulator for VHDL, a Hardware Description Language.
@@ -78,7 +91,7 @@
 Package: ghdl-llvm
 Architecture: any
 Build-Profiles: <!pkg.ghdl.nollvm>
-Depends: ghdl (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends},
+Depends: ghdl-common (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends},
 	zlib1g-dev
 Description: VHDL compiler/simulator (LLVM backend)
  GHDL is a compiler and simulator for VHDL, a Hardware Description Language.

=== debian/rules ===
--- 
+++ 
@@ -47,8 +47,8 @@
 %:
 	dh ${@}
 
-override_dh_missing:
-	dh_missing --list-missing
+override_dh_installdocs:
+	dh_installdocs --link-doc=ghdl-common
 
 override_dh_auto_configure:
 	mkdir -p $(BUILDDIR)/mcode $(BUILDDIR)/llvm $(BUILDDIR)/gcc
@@ -60,7 +60,7 @@
 		cd $(BUILDDIR)/mcode; \
 		../../configure --srcdir=../.. --prefix=/usr \
 			--libdir=lib/ghdl/mcode --incdir=lib/ghdl/include \
-			--enable-openieee; \
+			--disable-libghdl; \
 	fi
 	@echo
 	@echo ------------------------------------------------------------
@@ -70,7 +70,8 @@
 		cd $(BUILDDIR)/llvm; \
 		../../configure --srcdir=../.. --prefix=/usr \
 			--libdir=lib/ghdl/llvm --incdir=lib/ghdl/include \
-			--enable-openieee --with-llvm-config; \
+			--disable-libghdl \
+			--with-llvm-config; \
 	fi
 	@echo
 	@echo ------------------------------------------------------------
@@ -90,7 +91,8 @@
 		debian/rules patch; \
 		../../configure --srcdir=../.. --prefix=/usr \
 			--libdir=lib/ghdl/gcc --incdir=lib/ghdl/include \
-			--enable-openieee --with-gcc=src; \
+			--disable-libghdl \
+			--with-gcc=src; \
 		make copy-sources; \
 		mkdir gccbuild; \
 		cd gccbuild; \
@@ -174,3 +176,4 @@
 		mv debian/tmp/usr/lib/ghdl/gcc/vhdl/src debian/tmp/usr/lib/ghdl; \
 		ln -s ../../src debian/tmp/usr/lib/ghdl/gcc/vhdl/src; \
 	fi
+	$(RM) debian/tmp/usr/lib/ghdl/src/ieee2008/LICENSE

## ghdl 1.0.0%2Bdfsg

=== src/ortho/debug/Makefile ===
#  -*- Makefile -*- for the ortho-code back-end
#  Copyright (C) 2005 Tristan Gingold
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <gnu.org/licenses>.
BE=debug
ortho_srcdir=..

orthobe_srcdir=$(ortho_srcdir)/$(BE)

GNATMAKE=gnatmake
CC=gcc
CFLAGS=-g
ALL_GNAT_FLAGS=-pipe -g -gnato -gnatwaeu -gnatf -gnaty3befhkmr
GNATMAKE_FLAGS=$(ALL_GNAT_FLAGS) $(GNATFLAGS) -aI$(ortho_srcdir) -aI$(orthobe_srcdir) -aI.
#LARGS=-largs -static
SED=sed

all: $(ortho_exec)


$(ortho_exec): force $(ortho_srcdir)/$(BE)/ortho_debug.ads
	$(GNATMAKE) -o $@ $(GNATMAKE_FLAGS) ortho_debug-main -bargs -E $(LARGS)

clean:
	$(RM) -f *.o *.ali *~ b~*.ad? ortho_nodes-main
	$(RM) ortho_debug.ads

force:

ORTHO_BASENAME=ortho_debug

# Automatically build ortho_debug.ads from ortho_node.common.ads and
# ortho_debug.private.ads
include $(ortho_srcdir)/Makefile.inc
